//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

public class Commune: JSONDecodable, JSONEncodable, PrettyPrintable {

    public var codeInsee: String?

    public var codePostaux: [String]?

    public var latitude: String?

    public var longitude: String?

    public var nom: String?

    public init(codeInsee: String? = nil, codePostaux: [String]? = nil, latitude: String? = nil, longitude: String? = nil, nom: String? = nil) {
        self.codeInsee = codeInsee
        self.codePostaux = codePostaux
        self.latitude = latitude
        self.longitude = longitude
        self.nom = nom
    }

    public required init(jsonDictionary: JSONDictionary) throws {
        codeInsee = jsonDictionary.json(atKeyPath: "codeInsee")
        codePostaux = jsonDictionary.json(atKeyPath: "codePostaux")
        latitude = jsonDictionary.json(atKeyPath: "latitude")
        longitude = jsonDictionary.json(atKeyPath: "longitude")
        nom = jsonDictionary.json(atKeyPath: "nom")
    }

    public func encode() -> JSONDictionary {
        var dictionary: JSONDictionary = [:]
        if let codeInsee = codeInsee {
            dictionary["codeInsee"] = codeInsee
        }
        if let codePostaux = codePostaux {
            dictionary["codePostaux"] = codePostaux
        }
        if let latitude = latitude {
            dictionary["latitude"] = latitude
        }
        if let longitude = longitude {
            dictionary["longitude"] = longitude
        }
        if let nom = nom {
            dictionary["nom"] = nom
        }
        return dictionary
    }

    /// pretty prints all properties including nested models
    public var prettyPrinted: String {
        return "\(Swift.type(of: self)):\n\(encode().recursivePrint(indentIndex: 1))"
    }
}
